// Code generated by mockery v2.53.0. DO NOT EDIT.

package environment

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	db "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/db"

	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockService is an autogenerated mock type for the Service type
type MockService struct {
	mock.Mock
}

// CreateEnvironment provides a mock function with given fields: ctx, input
func (_m *MockService) CreateEnvironment(ctx context.Context, input *CreateEnvironmentInput) (*models.Environment, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateEnvironment")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateEnvironmentInput) (*models.Environment, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateEnvironmentInput) *models.Environment); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateEnvironmentInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateOrganizationEnvironmentRule provides a mock function with given fields: ctx, input
func (_m *MockService) CreateOrganizationEnvironmentRule(ctx context.Context, input *CreateOrganizationEnvironmentRuleInput) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateOrganizationEnvironmentRule")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateOrganizationEnvironmentRuleInput) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateOrganizationEnvironmentRuleInput) *models.EnvironmentRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateOrganizationEnvironmentRuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateProjectEnvironmentRule provides a mock function with given fields: ctx, input
func (_m *MockService) CreateProjectEnvironmentRule(ctx context.Context, input *CreateProjectEnvironmentRuleInput) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateProjectEnvironmentRule")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateProjectEnvironmentRuleInput) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateProjectEnvironmentRuleInput) *models.EnvironmentRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateProjectEnvironmentRuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteEnvironment provides a mock function with given fields: ctx, input
func (_m *MockService) DeleteEnvironment(ctx context.Context, input *DeleteEnvironmentInput) error {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for DeleteEnvironment")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *DeleteEnvironmentInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteEnvironmentRule provides a mock function with given fields: ctx, input
func (_m *MockService) DeleteEnvironmentRule(ctx context.Context, input *DeleteEnvironmentRuleInput) error {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for DeleteEnvironmentRule")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *DeleteEnvironmentRuleInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetEnvironmentByID provides a mock function with given fields: ctx, id
func (_m *MockService) GetEnvironmentByID(ctx context.Context, id string) (*models.Environment, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentByID")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Environment, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Environment); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentByPRN provides a mock function with given fields: ctx, prn
func (_m *MockService) GetEnvironmentByPRN(ctx context.Context, prn string) (*models.Environment, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentByPRN")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Environment, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Environment); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentRuleByID provides a mock function with given fields: ctx, id
func (_m *MockService) GetEnvironmentRuleByID(ctx context.Context, id string) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRuleByID")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.EnvironmentRule); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentRuleByPRN provides a mock function with given fields: ctx, prn
func (_m *MockService) GetEnvironmentRuleByPRN(ctx context.Context, prn string) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRuleByPRN")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.EnvironmentRule); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentRules provides a mock function with given fields: ctx, input
func (_m *MockService) GetEnvironmentRules(ctx context.Context, input *GetEnvironmentRulesInput) (*db.EnvironmentRulesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRules")
	}

	var r0 *db.EnvironmentRulesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentRulesInput) (*db.EnvironmentRulesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentRulesInput) *db.EnvironmentRulesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*db.EnvironmentRulesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetEnvironmentRulesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentRulesByIDs provides a mock function with given fields: ctx, ids
func (_m *MockService) GetEnvironmentRulesByIDs(ctx context.Context, ids []string) ([]*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, ids)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRulesByIDs")
	}

	var r0 []*models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, []string) ([]*models.EnvironmentRule, error)); ok {
		return rf(ctx, ids)
	}
	if rf, ok := ret.Get(0).(func(context.Context, []string) []*models.EnvironmentRule); ok {
		r0 = rf(ctx, ids)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, []string) error); ok {
		r1 = rf(ctx, ids)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironments provides a mock function with given fields: ctx, input
func (_m *MockService) GetEnvironments(ctx context.Context, input *GetEnvironmentsInput) (*db.EnvironmentsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironments")
	}

	var r0 *db.EnvironmentsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentsInput) (*db.EnvironmentsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentsInput) *db.EnvironmentsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*db.EnvironmentsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetEnvironmentsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentsByIDs provides a mock function with given fields: ctx, idList
func (_m *MockService) GetEnvironmentsByIDs(ctx context.Context, idList []string) ([]models.Environment, error) {
	ret := _m.Called(ctx, idList)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentsByIDs")
	}

	var r0 []models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, []string) ([]models.Environment, error)); ok {
		return rf(ctx, idList)
	}
	if rf, ok := ret.Get(0).(func(context.Context, []string) []models.Environment); ok {
		r0 = rf(ctx, idList)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, []string) error); ok {
		r1 = rf(ctx, idList)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateEnvironment provides a mock function with given fields: ctx, input
func (_m *MockService) UpdateEnvironment(ctx context.Context, input *UpdateEnvironmentInput) (*models.Environment, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for UpdateEnvironment")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *UpdateEnvironmentInput) (*models.Environment, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *UpdateEnvironmentInput) *models.Environment); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *UpdateEnvironmentInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateEnvironmentRule provides a mock function with given fields: ctx, input
func (_m *MockService) UpdateEnvironmentRule(ctx context.Context, input *UpdateEnvironmentRuleInput) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for UpdateEnvironmentRule")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *UpdateEnvironmentRuleInput) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *UpdateEnvironmentRuleInput) *models.EnvironmentRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *UpdateEnvironmentRuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockService creates a new instance of MockService. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockService(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockService {
	mock := &MockService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
